<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetLayerDataResponse StructType
 * @subpackage Structs
 */
class GetLayerDataResponse extends AbstractStructBase
{
    /**
     * The Layer
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\Layer[]
     */
    public $Layer;
    /**
     * The Timings
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Timings
     */
    public $Timings;
    /**
     * Constructor method for GetLayerDataResponse
     * @uses GetLayerDataResponse::setLayer()
     * @uses GetLayerDataResponse::setTimings()
     * @param \StructType\Layer[] $layer
     * @param \StructType\Timings $timings
     */
    public function __construct(array $layer = array(), \StructType\Timings $timings = null)
    {
        $this
            ->setLayer($layer)
            ->setTimings($timings);
    }
    /**
     * Get Layer value
     * @return \StructType\Layer[]|null
     */
    public function getLayer()
    {
        return $this->Layer;
    }
    /**
     * This method is responsible for validating the values passed to the setLayer method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLayer method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLayerForArrayConstraintsFromSetLayer(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getLayerDataResponseLayerItem) {
            // validation for constraint: itemType
            if (!$getLayerDataResponseLayerItem instanceof \StructType\Layer) {
                $invalidValues[] = is_object($getLayerDataResponseLayerItem) ? get_class($getLayerDataResponseLayerItem) : sprintf('%s(%s)', gettype($getLayerDataResponseLayerItem), var_export($getLayerDataResponseLayerItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Layer property can only contain items of type \StructType\Layer, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Layer value
     * @throws \InvalidArgumentException
     * @param \StructType\Layer[] $layer
     * @return \StructType\GetLayerDataResponse
     */
    public function setLayer(array $layer = array())
    {
        // validation for constraint: array
        if ('' !== ($layerArrayErrorMessage = self::validateLayerForArrayConstraintsFromSetLayer($layer))) {
            throw new \InvalidArgumentException($layerArrayErrorMessage, __LINE__);
        }
        $this->Layer = $layer;
        return $this;
    }
    /**
     * Add item to Layer value
     * @throws \InvalidArgumentException
     * @param \StructType\Layer $item
     * @return \StructType\GetLayerDataResponse
     */
    public function addToLayer(\StructType\Layer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Layer) {
            throw new \InvalidArgumentException(sprintf('The Layer property can only contain items of type \StructType\Layer, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Layer[] = $item;
        return $this;
    }
    /**
     * Get Timings value
     * @return \StructType\Timings|null
     */
    public function getTimings()
    {
        return $this->Timings;
    }
    /**
     * Set Timings value
     * @param \StructType\Timings $timings
     * @return \StructType\GetLayerDataResponse
     */
    public function setTimings(\StructType\Timings $timings = null)
    {
        $this->Timings = $timings;
        return $this;
    }
}
